org.apache.hadoop.io.compress

## Class BlockDecompressorStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.hadoop.io.compress.CompressionInputStream
    - - org.apache.hadoop.io.compress.DecompressorStream
      - - org.apache.hadoop.io.compress.BlockDecompressorStream

- All Implemented Interfaces:
    Closeable, AutoCloseable, Seekable

      @InterfaceAudience.Public
       @InterfaceStability.Evolving
      public class BlockDecompressorStream
      extends DecompressorStream

  A `DecompressorStream` which works with 'block-based' based compression algorithms, as opposed to 'stream-based' compression algorithms.

- - ### Field Summary

    - ### Fields inherited from class org.apache.hadoop.io.compress.DecompressorStream

      `buffer, closed, decompressor, eof`

    - ### Fields inherited from class org.apache.hadoop.io.compress.CompressionInputStream

      `in, maxAvailableData`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BlockDecompressorStream(InputStream in)`
    `` | `BlockDecompressorStream(InputStream in, Decompressor decompressor)` Create a `BlockDecompressorStream`.
    `` | `BlockDecompressorStream(InputStream in, Decompressor decompressor, int bufferSize)` Create a `BlockDecompressorStream`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `decompress(byte[] b, int off, int len)`
    `protected int` | `getCompressedData()`
    `void` | `resetState()` Reset the decompressor to its initial state and discard any buffered data, as the underlying stream may have been repositioned.

    - ### Methods inherited from class org.apache.hadoop.io.compress.DecompressorStream

      `available, checkStream, close, mark, markSupported, read, read, reset, skip`

    - ### Methods inherited from class org.apache.hadoop.io.compress.CompressionInputStream

      `getPos, seek, seekToNewSource`

    - ### Methods inherited from class java.io.InputStream

      `read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BlockDecompressorStream

          public BlockDecompressorStream(InputStream in,
                                         Decompressor decompressor,
                                         int bufferSize)
                                  throws IOException

      Create a `BlockDecompressorStream`.
      Parameters:
        `in` - input stream
        `decompressor` - decompressor to use
        `bufferSize` - size of buffer
      Throws:
        `IOException`

    - #### BlockDecompressorStream

          public BlockDecompressorStream(InputStream in,
                                         Decompressor decompressor)
                                  throws IOException

      Create a `BlockDecompressorStream`.
      Parameters:
        `in` - input stream
        `decompressor` - decompressor to use
      Throws:
        `IOException`

    - #### BlockDecompressorStream

          protected BlockDecompressorStream(InputStream in)
                                     throws IOException

      Throws:
        `IOException`

  - ### Method Detail

    - #### decompress

          protected int decompress(byte[] b,
                                   int off,
                                   int len)
                            throws IOException

      Overrides:
        `decompress` in class `DecompressorStream`
      Throws:
        `IOException`

    - #### getCompressedData

          protected int getCompressedData()
                                   throws IOException

      Overrides:
        `getCompressedData` in class `DecompressorStream`
      Throws:
        `IOException`

    - #### resetState

          public void resetState()
                          throws IOException

      Description copied from class: `CompressionInputStream`
      Reset the decompressor to its initial state and discard any buffered data, as the underlying stream may have been repositioned.
      Overrides:
        `resetState` in class `DecompressorStream`
      Throws:
        `IOException`

Copyright © 2022 Apache Software Foundation. All rights reserved.